#
#   Copyright 2012 Andrii Golovynskyi
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

$ENV{LANG} = "C";

sub gen_makefile {
  my ($d,$a,$p,$l,$c) = @_;

  if ( -e "$d/Makefile" ) {
        return ("Found Makefile, skipping Makefile generation\n");
  } else {
    my $res = "Generating Makefile\n";
    my $compiler = $config{PARTITION}->{"$p"}->{"$c"."_"."$l"};
    my $srcfilemask =  $config{"$l"."_FILEMASK"};
    my $cflags = $config{PARTITION}->{"$p"}->{"$l"."_CFLAGS"};
    my $ldflags = $config{PARTITION}->{"$p"}->{"$l"."_LDFLAGS"};

    if (not defined $compiler) {
      return ("Compiler is not defined in this partition!\n");
    }
    if (not defined $srcfilemask) {
      return ("File mask for this language is not defined in this partition!\n");
    }
    if (not defined $cflags) {
      $res .= "Warning: Compiler flags for $l are not defined in this partition\n";
      $cflags="";
    }
    if (not defined $ldflags) {
      $res .= "Warning: Linker flags for $l are not defined in this partition\n";
      $ldflags="";
    }

    my $date = `date`;
    my $makefile = <<EOT;
# $date
# Makefile generator
# Automatically generated file, change it to fit your needs

all: $a
$a:
        $compiler $srcfilemask $cflags $ldflags -o \$\@
EOT
    $res .= "Makefile:\n$makefile\n";
    open (MAKEFILE, ">$d/Makefile");
    print (MAKEFILE "$makefile");
    close (MAKEFILE);
    return $res;
  }
}

1;
