<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>SCMS environment verification</title>
<style>
.e {color:#ff0000}
.o {color:#16a008}
.w {color:#ffd700}
</style>
</head>
<body>
<form action="" method="post">
 To check LDAP connection input login <input type="text" name="login" /> 
	and password <input type="password" name="pass" /> 
	of any cluster user and press <input type="submit" value="ok" />.
</form>
<table>
 <tr><th>Section</th><th>Result</th><th>Recommendation</th></tr>
<?php
function return_bytes($val) {
	$val = trim($val);
	$last = strtolower($val[strlen($val)-1]);
	switch($last) {
		case 'g':
			$val *= 1024;
		case 'm':
			$val *= 1024;
		case 'k':
			$val *= 1024;
	}
	return $val;
}

error_reporting(E_ALL^E_NOTICE);
//print_r(get_loaded_extensions ());
require('../site/config.php');

$need_ext = array('json', 'mbstring', 'session');
$mysql_tbls = array('dictionary', 'grid_clusters', 'grid_resources', 'grid_tasks', 'languages', 'profiles', 'users', 'users_to_clusters');

$results = array();

// authorization

switch (_auth_service) {

 case 'ldap':
	 
  $r = extension_loaded('ldap');
	 $results['authorization'][] = array('Extension "ldap"', $r ? '' : 'e', $r ? 'loaded' : 'missing');
		
		if ($r) {
		 $r = (defined('_ldap_host') and _ldap_host and 
			      defined('_ldap_port') and _ldap_port and 
									defined('_ldap_base') and _ldap_base);
			$results['authorization'][] = array('LDAP configuration', $r ? '' : 'e', $r ? 'exists' : 'missing');
			
			if ($_POST['login'] and $_POST['pass']) {
			 $ds = ldap_connect(_ldap_host, _ldap_port);
				$r = @ldap_bind($ds, 'uid='.$_POST['login'].','._ldap_base, $_POST['pass']);
 			$results['authorization'][] = array('LDAP connection', $r ? '' : 'e', $r ? 'successful' : 'failure');
			} else
			 $results['authorization'][] = array('LDAP connection', 'w', 'not verified', 'use form above');
		}
		
	break;
	
	case 'pam':
	
	 $r = extension_loaded('pam');
	 $results['authorization'][] = array('Extension "pam"', $r ? '' : 'e', $r ? 'loaded' : 'missing');
		
	break;
	
	default: 
	 $results['authorization'][] = array('Authorisation service config', 'e', 'missing', 'choose between "ldap" or "pam" options');
	
}

// mysql

$r = extension_loaded('mysql');
$results['MySQL'][] = array('Extension "mysql"', $r ? '' : 'e', $r ? 'loaded' : 'missing');

if ($r) {
 $r = (defined('_mysql_host') and defined('_mysql_login') and defined('_mysql_db'));
 $results['MySQL'][] = array('MySQL database config', $r ? '' : 'e', $r ? 'exists' : 'missing', 'need to set up');

 $r = @mysql_connect(_mysql_host, _mysql_login, _mysql_pass);
 $results['MySQL'][] = array('MySQL connection', $r ? '' : 'e', $r ? 'successful' : 'failure');

	$r = @mysql_select_db(_mysql_db);
	$results['MySQL'][] = array('MySQL database connection', $r ? '' : 'e', $r ? 'successful' : 'failure');
	
	if ($r) {
	 $tbls = array();
		$result = mysql_query('show tables');
		while ($row = mysql_fetch_array($result))
		 $tbls[] = $row[0];
		
		foreach ($mysql_tbls as $tbl) {
		 $r = in_array($tbl, $tbls) !== false;
			$results['MySQL'][] = array('Table '.$tbl, $r ? '' : 'w', $r ? 'exists' : 'missing', 'add this table using install.php script'); 
		}	
	}
}

// other extension

foreach ($need_ext as $e) {
 $r = extension_loaded($e);
	$results['Extensions'][] = array('Extension "'.$e.'"', $r ? '' : 'e', $r ? 'loaded' : 'missing');
}

// hydra

$pipes = array();

$process = proc_open(_hydra_hctl.' -h', array(array("pipe", "r"), array("pipe", "w"), array("pipe", "w")), $pipes);
if (is_resource($process)) {
	$r = stream_get_contents($pipes[1]);
	$r = ($r and fclose($pipes[0]) and fclose($pipes[1]) and fclose($pipes[2]) and !proc_close($process));	
} else
	$r = false;
if (1 and '') echo 1;
$results['hydra'][] = array('Executing hydra client', $r ? '' : 'e', $r ? 'ok' : 'error');
if ($_POST['login'] and $_POST['pass']) {
	$process = proc_open(_hydra_hctl.' -i '._hydrad_host.' -u '.$_POST['login'].' hydra', array(array("pipe", "r"), array("pipe", "w"), array("pipe", "w")), $pipes);
	if (is_resource($process)) {
		$r = fwrite($pipes[0], '[{"command":"home"}]');
		$r = ($r and fclose($pipes[0]));
		$s = ($r and stream_get_contents($pipes[1]));
		$r = ($r and fclose($pipes[1]) and fclose($pipes[2]) and !proc_close($process));	
	} else
		$r = false;
 $results['hydra'][] = array('Executing hydrad server', $r ? '' : 'e', $r ? 'success' : 'error');		
} else
 $results['hydra'][] = array('Executing hydrad server', 'w', 'not verified', 'use form above');
 
	
// php.ini
	
$r = ini_get('date.timezone');
$results['php.ini'][] = array('Timezone', $r ? '' : 'e', $r ? $r : 'empty', 
                              'set <a href="http://www.php.net/manual/en/timezones.php" target="_blank">your timezone</a>');

$r = ini_get('safe_mode');
$results['php.ini'][] = array('Safe mode', $r ? 'w' : '', $r ? 'on' : 'off', 'set to off');

$r = ini_get('short_open_tag');
$results['php.ini'][] = array('Short open tags', $r ? '' : 'e', $r ? 'on' : 'off', 'set to on');

$r = ini_get('register_globals');
$results['php.ini'][] = array('Register globals', $r ? 'w' : '', $r ? 'on' : 'off');

$m = ini_get('memory_limit');
$results['php.ini'][] = array('Memory limit', return_bytes($m) < 50*1024*1024 ? 'w' : '', $m, 'at least 50');

$p = ini_get('post_max_size');
$results['php.ini'][] = array('POST max size', return_bytes($p) < 50*1024*1024 ? 'w' : '', $p, 'at least 50');

$r = ini_get('max_execution_time');
$results['php.ini'][] = array('Max execution time', $r < 60 ? 'w' : '', $r, 'at least 60');

$r = ini_get('file_uploads');
$results['php.ini'][] = array('File uploads', $r ? '' : 'w', $r ? 'on' : 'off', 'activate to allow uploads');

$u = ini_get('upload_max_filesize');
$results['php.ini'][] = array('Upload max filesize', return_bytes($u) < 10*1024*1024 ? 'w' : '', $u, 'at least 10M recommended');

$results['php.ini'][] = array('Upload filesize <= POST max size <= memory limit', 
                              (return_bytes($u) <= return_bytes($p) and return_bytes($p) <= return_bytes($m)) ? '' : 'w', 
																														$u.' <= '.$p.' <= '.$m, 
																														'make proper limits'); 

// file permissions

$r = is_writable('../cache/');
$results['permissions'][] = array('cache folder', $r ? '' : 'e', $r ? 'writable' : 'not writable', 'set writable');


//

$error = $warning = 0;
$section = '';
foreach ($results as $s => $section) {
 echo '<tr><th colspan="4">'.$s.'</th></tr>';
	foreach ($section as $result) {		
  echo '<tr><td>'.$result[0].'</td><td class="'.($result[1] ? $result[1] : 'o').'">'.$result[2].'</td><td>'.($result[1] ? $result[3] : '').'</td></tr>';
 	$error += ($result[1] == 'e');
 	$warning += ($result[1] == 'w');
	}	
}	

echo '<tr><td>&nbsp;</td></tr>'.
     '<tr><td>General result:</td><td '.($error ? 'class="e">Failure' : ($warning ? 'class="w">Warning' : 'class="o">OK')).'</td></tr>';
?>
</table>
</body>
</html>