Ext.form.FieldSet.prototype.getCheckbox = function()  {
  return this.checkbox;
}

Ext.form.FieldSet.prototype.getValue = function() {
  return this.getCheckbox().dom.checked;
}

Ext.form.FieldSet.prototype.setValue = function(value) {
  this.getCheckbox().dom.checked = value;
  this.onCheckClick();
}

Ext.override(Ext.form.BasicForm, {     
		findField: function(id){         
				var field = this.items.get(id);      
				if(!field){             
						this.items.each(function(f){                 
								if(f.isFormField && (f.dataIndex == id || f.id == id || f.getName() == id)){                     
										field = f;                     
								return false;                 
						} else if (f.items) {                     
								//do it again for each subitem                     
								f.items.each(function(f2){                         
												if(f2.isFormField && (f2.dataIndex == id || f2.id == id || f2.getName() == id)){                             
														field = f2;                             
														return false;                         
												}                     
										});                 
								}             
						});         
				}         
				return field || null;    
		} 
});

Ext.apply(Ext.form.VTypes, {
		password: function(val, field) { // password match
				return field.initialPassField ? val == field.initialPassField.getValue() : true;
		},
		passwordText: ~'Введені паролі не співпадають'~,
});

Ext.ux.IconCombo = Ext.extend(Ext.form.ComboBox, {
	 initComponent: function() {
		  Ext.apply(this, {
			   tpl: '<tpl for="."><div class="x-combo-list-item ux-icon-combo-item {' + this.iconClsField + '}">' +
				       '{' + this.displayField + '}</div></tpl>'
		  });

		  Ext.ux.IconCombo.superclass.initComponent.apply(this, arguments);
	 },

	 onRender: function(ct, position) {
		  Ext.ux.IconCombo.superclass.onRender.apply(this, arguments);

		  this.wrap.applyStyles({position:'relative'});
		  this.el.addClass('ux-icon-combo-input');

		  this.icon = Ext.DomHelper.append(this.el.up('div.x-form-field-wrap'), {
			   tag: 'div', style:'position:absolute'
		  });
	 },

	 afterRender: function() {
	  	Ext.ux.IconCombo.superclass.afterRender.apply(this, arguments);
		  if (undefined !== this.value) {
			   this.setValue(this.value);
		  }
	 },
	 
		setIconCls: function() {
    var i = this.store.findExact(this.valueField, this.getValue()),
				    rec = i > -1 ? this.store.getAt(i) : false;
				if (rec && this.icon) {
      this.icon.className = 'ux-icon-combo-icon ' + rec.get(this.iconClsField);
    }
	 },
		
		setValue: function(value) {
    Ext.ux.IconCombo.superclass.setValue.call(this, value);
    this.setIconCls();
  },

	 clearValue: function() {
		  Ext.ux.IconCombo.superclass.clearValue.call(this);
		  if (this.icon) {
			   this.icon.className = '';
		  }
	 }
});

Ext.ns('Ext.ux.form');
Ext.ux.form.FileUploadField = Ext.extend(Ext.form.TextField,  {
    buttonText: 'Browse...',
    buttonOnly: false,
    buttonOffset: 3,
    // private
    readOnly: true,
    autoSize: Ext.emptyFn,
				multiple: false,
    // private
    initComponent: function(){
        Ext.ux.form.FileUploadField.superclass.initComponent.call(this);

        this.addEvents(
            'fileselected'
        );
    },
    // private
    onRender : function(ct, position){
        Ext.ux.form.FileUploadField.superclass.onRender.call(this, ct, position);
        this.wrap = this.el.wrap({cls:'x-form-field-wrap x-form-file-wrap'});
        this.el.addClass('x-form-file-text');
        this.el.dom.removeAttribute('name');
        this.createFileInput();
        var btnCfg = Ext.applyIf(this.buttonCfg || {}, {
            text: this.buttonText
        });
        this.button = new Ext.Button(Ext.apply(btnCfg, {
            renderTo: this.wrap,
            cls: 'x-form-file-btn' + (btnCfg.iconCls ? ' x-btn-icon' : '')
        }));
        if(this.buttonOnly){
            this.el.hide();
            this.wrap.setWidth(this.button.getEl().getWidth());
        }
        this.bindListeners();
        this.resizeEl = this.positionEl = this.wrap;
    },
    bindListeners: function(){
        this.fileInput.on({
            scope: this,
            mouseenter: function() {
                this.button.addClass(['x-btn-over','x-btn-focus'])
            },
            mouseleave: function(){
                this.button.removeClass(['x-btn-over','x-btn-focus','x-btn-click'])
            },
            mousedown: function(){
                this.button.addClass('x-btn-click')
            },
            mouseup: function(){
                this.button.removeClass(['x-btn-over','x-btn-focus','x-btn-click'])
            },
            change: function(){
                var d = this.fileInput.dom, v;
																if (d.files && d.files.length) {
																	 v = [];
																		for (var i = 0; i < d.files.length; i++)
																				v.push(d.files[i].name.split(/[\/\\]/).pop());
																		v = v.join(', ');
																} else
																  v = d.value.split(/[\/\\]/).pop();
																		
                this.setValue(v);
                this.fireEvent('fileselected', this, v);    
            }
        }); 
    },
    createFileInput : function() {
        this.fileInput = this.wrap.createChild({
            id: this.getFileInputId(),
            name: this.name||this.getId(),
            cls: 'x-form-file',
            tag: 'input',
            type: 'file',
												multiple: this.multiple ? 'multiple' : '',
            size: 1
        });
    },
    reset : function(){
        this.fileInput.remove();
        this.createFileInput();
        this.bindListeners();
        Ext.ux.form.FileUploadField.superclass.reset.call(this);
    },
    getFileInputId: function(){
        return this.id + '-file';
    },
    // private
    onResize : function(w, h){
        Ext.ux.form.FileUploadField.superclass.onResize.call(this, w, h);
        this.wrap.setWidth(w);
        if(!this.buttonOnly){
            var w = this.wrap.getWidth() - this.button.getEl().getWidth() - this.buttonOffset;
            this.el.setWidth(w);
        }
    },
    // private
    onDestroy: function(){
        Ext.ux.form.FileUploadField.superclass.onDestroy.call(this);
        Ext.destroy(this.fileInput, this.button, this.wrap);
    },
    onDisable: function(){
        Ext.ux.form.FileUploadField.superclass.onDisable.call(this);
        this.doDisable(true);
    },
    onEnable: function(){
        Ext.ux.form.FileUploadField.superclass.onEnable.call(this);
        this.doDisable(false);
    },
    // private
    doDisable: function(disabled){
        this.fileInput.dom.disabled = disabled;
        this.button.setDisabled(disabled);
    },
    // private
    preFocus : Ext.emptyFn,
    // private
    alignErrorIcon : function(){
        this.errorIcon.alignTo(this.wrap, 'tl-tr', [2, 0]);
    }
});

Ext.reg('fileuploadfield', Ext.ux.form.FileUploadField);

Ext.apply(Ext.util.Format, {
		periodFormat: function (x) {
				var s = x % 60;
				var m = Math.floor(x / 60) % 60;
				var h = Math.floor(x / 3600) % 24;
				var d = Math.floor(x / 86400);
				return x ? (d > 0 ? d + ' ' : '') + h + ':' + m + ':' + s : '';
		},
		fileSize: function(size) {
				if (size < 1024) 
						return size + " b";
				else if (size < 1048576) 
						return (Math.round(size*10/1024)/10) + " KB";
				else if (size < 1073741824) 
						return (Math.round(size*10/1048576)/10) + " MB";
				else if (size < 1099511627776)
						return (Math.round(size*10/1073741824)/10) + " GB";
				else if (size < 1125899906842624)
						return (Math.round(size*10/1099511627776)/10) + " TB";
		}
});
	
function fileName(s) {
		return (s + '').match(/[^\/]+$/)[0];
}

function baseDir(s) {
		return s.replace(/[^\/\\]+$/,'');
}
