app.TabGridMap = Ext.extend(Ext.BoxComponent, {
		initComponent: function () {

    var config = {
				  infowindow: new google.maps.InfoWindow(),
      zoomLevel: 4,
      gmapType: 'map',
      border: false
    };

    Ext.applyIf(this, config);

    app.TabGridMap.superclass.initComponent.call(this);

  },

  afterRender: function () {

    var wh = this.ownerCt.getSize();
    Ext.applyIf(this, wh);

    app.TabGridMap.superclass.afterRender.call(this);

    this.gmap = new google.maps.Map(this.getEl().dom, {
      mapTypeId: google.maps.MapTypeId.ROADMAP,
      panControl: false,
      streetViewControl: false,
      zoom: this.zoomLevel
    });

    if (typeof this.setCenter === 'object') {
      var point = new google.maps.LatLng(this.setCenter.lat, this.setCenter.lng);
      this.gmap.setCenter(point);
    }

    google.maps.event.addListener(this.gmap, 'load', this, function () {
      this.onMapReady();
    });
    
				this.interface.storeClusters.on('beforeload', function(store){
						var i, d;
						for (i = 0; i < store.getCount(); i++) {
								d = store.getAt(i).data;
								d.marker.setMap(null);
								d.marker = null;
								store.getAt(i).commit();
						}								  
				});
    
				var self = this;
				
				this.markerClick = function(){
						var d = self.interface.storeClusters.getAt(this.id).data;
						self.infowindow.setContent('<h3>' + d.hostname + '</h3><p>' + d.organization + ',<br>' + d.country + ', ' + 
																																	d.city + ',<br>' + d.location + ', ' + d.address + '</p>');
						self.infowindow.open(this.getMap(), this);
		  }
								
				this.interface.storeClusters.on('load', function(store, records){
						var i, d, o;
						for (i = 0; i < records.length; i++) {
								d = records[i].data;
								
								if (d.geo_lat != null && d.geo_lng != null) {
										o = {
												map: this.gmap,
												position: new google.maps.LatLng(d.geo_lat, d.geo_lng),
												title: d.hostname,
												id: i
										};
										if (d.avail == 'up') {
										  o.icon = 'images/map/marker_green.png';
												o.shadow = {url: 'https://maps.gstatic.com/mapfiles/ms2/micons/msmarker.shadow.png', anchor: new google.maps.Point(14, 34)}
										}
										d.marker = new google.maps.Marker(o);
										google.maps.event.addListener(d.marker, 'click', this.markerClick);
								}
								records[i].commit();
						}			
				}, this);
				
				this.interface.storeClusters.load();
				
  },
		
  onMapReady: function () {

  },
  
		onResize: function (w, h) {

    if (typeof this.getMap() == 'object') {
      google.maps.event.trigger(this.gmap, 'resize');
    }

    app.TabGridMap.superclass.onResize.call(this, w, h);

  },
  setSize: function (width, height, animate) {

    if (typeof this.getMap() == 'object') {
      google.maps.event.trigger(this.gmap, 'resize');
    }

    app.TabGridMap.superclass.setSize.call(this, width, height, animate);

  },
  getMap: function () {

    return this.gmap;

  },
  getCenter: function () {

    return this.getMap().getCenter();

  },
  getCenterLatLng: function () {

    var ll = this.getCenter();
    return {
      lat: ll.lat(),
      lng: ll.lng()
    };

  },
  addMarker: function (point, marker, clear, center, listeners) {

    Ext.applyIf(marker, G_DEFAULT_ICON);

    if (clear === true) {
      this.getMap().clearOverlays();
    }
    if (center === true) {
      this.getMap().setCenter(point, this.zoomLevel);
    }

    var mark = new GMarker(point, marker);
    if (typeof listeners === 'object') {
      for (evt in listeners) {
        GEvent.bind(mark, evt, this, listeners[evt]);
      }
    }
    this.getMap().addOverlay(mark);

  }
});

Ext.reg('gridmap', app.TabGridMap);