app.RadioColumn = Ext.extend(Ext.grid.Column, {
  renderer: function(v, p, record) {
    p.css += ' x-grid3-check-col-td';
    return '<div class="x-grid3-check-col' + (v ? '-on' : '') + '"></div>';
  },
  
		processEvent : function(name, e, grid, rowIndex, colIndex){
    if (name == 'mousedown') {
      this.onMouseDown(e, e.getTarget(), grid, rowIndex, colIndex);
      return false;
    } else {
      return Ext.grid.Column.prototype.processEvent.apply(this, arguments);
    }
  },
  
		onMouseDown : function(e, t, grid, rowIndex, colIndex){
				if(e.button === 0 && t.className.indexOf('x-grid3-check-col') != -1) { // Only fire if left-click
				 	e.stopEvent();
						var store = grid.getStore(), rec = store.getAt(rowIndex);

						if (rec.get(this.dataIndex)) {
        rec.set(this.dataIndex, false);    
								store.commitChanges();
								return;
      } else {
						  for (var i = 0; i < store.getCount(); i++) {
								  rec = store.getAt(i);
										rec.set(this.dataIndex, i == rowIndex);										  
								}
								store.commitChanges();
						}
				}
		}
});

app.SettingsPanel = Ext.extend(Ext.Panel, {
		title: ~'Налаштування'~,
		iconCls: 'x-tab-settings',
		frame: true,
		disabled: true,
		
		fillSettings: function(o) {
				if (Ext.isDefined(o.certificate)) {
				  this.taGridCertInfo.setValue(o.certificate);
						this.labelCertKey.setValue(o.key ? ~'Встановлено'~ : ~'Відсутній'~);
				}	else if (Ext.isObject(o)) {
				  this.formInterfaceSettings.getForm().setValues(o);
				  this.formGridSettings.getForm().setValues(o);
						this.interface.comboVO.setValue(o.default_vo_alias);
						this.tfCertPass.disable();
						this.tfCertPassConfirm.disable();
						this.tfMPPass.disable();
						this.tfMPPassConfirm.disable();
				}
		},
  
		loadVO: function(vo) {
			 vo = vo || [];
			 // set default vo
			 for (var i = 0; i < vo.length; i++)
				  vo[i]['default'] = this.interface.userSettings.default_vo_alias == vo[i].alias;
			 this.interface.storeVO.loadData(vo);
		},
		
		initComponent: function(){
			 var self = this;
										
				this.comboLanguages = new Ext.ux.IconCombo({
						fieldLabel: ~'Мова інтерфейсу'~,
						store: new Ext.data.ArrayStore({
								fields: ['id', 'n', 'cls'],
								data: languages
						}),
						displayField: 'n',
						valueField: 'id',
						iconClsField: 'cls',
						mode: 'local',
						forceSelection: true,
						allowBlank: false,
						editable: false,
						triggerAction: 'all',
						name: 'language_id',
						value: language_id,
						listeners: {
								select: function(){
										window.location = '/?language_id=' + this.getValue();
								}
						}				
				});
				
				this.formInterfaceSettings = new Ext.form.FormPanel({
						items: [{
								xtype: 'fieldset',
								title: ~'Налаштування інтерфейсу'~,
								labelWidth: 150,
								items: [this.comboLanguages]
						}]										
				});
				
				this.tfCertPass = new Ext.form.TextField({
						fieldLabel: ~"Пароль"~,
						name: 'cert_pass',
						inputType: 'password',
						disabled: true,
						allowBlank: false
				});
				
				this.tfCertPassConfirm = new Ext.form.TextField({
						fieldLabel: ~"Підтвердження паролю"~,
						name: 'cert_passc',
						inputType: 'password',
						disabled: true,
						vtype: 'password',
						initialPassField: this.tfCertPass,
						allowBlank: false
				});
				
				this.taGridCertInfo = new Ext.form.TextArea({
						fieldLabel: ~'Інформація про сертифікат'~,
						readOnly: true,
						height: 70,
						submitValue: false
				});
				
				this.tfMPServer = new Ext.form.TextField({
						fieldLabel: ~'Сервер'~,
						name: 'myproxy_server',
						allowBlank: false
    });
				
				this.tfMPLogin = new Ext.form.TextField({
				  fieldLabel: ~'Ім\'я користувача'~,
						name: 'myproxy_login',
						allowBlank: false
				});
				
				this.tfMPPass = new Ext.form.TextField({
						fieldLabel: ~"Пароль"~,
						name: 'myproxy_pass',
						inputType: 'password',
						disabled: true,
						allowBlank: false
				});

    this.tfMPPassConfirm = new Ext.form.TextField({
						fieldLabel: ~"Підтвердження паролю"~,
						name: 'myproxy_passc',
						inputType: 'password',
						disabled: true,
						vtype: 'password',
						initialPassField: this.tfMPPass,
						allowBlank: false
				});
						
				// radio listeners
				var rbl = {
					 check: function(f) {
  					 var mode = self.formGridSettings.getForm().getValues()['grid_auth_mode'];
		  				self.tfMPServer.setDisabled(mode != 'myproxy');
				  		self.tfMPLogin.setDisabled(mode != 'myproxy');
				  },
						afterrender: function(){
							 self.fillSettings(self.interface.userSettings);
						}
				};
				
				this.fsCert = new Ext.form.FieldSet({
				  title: ~'Налаштування грід-сертифіката'~,
						labelWidth: 150,
						defaults: {
							 anchor: '100%'
						},
						items: [{
								xtype: 'fileuploadfield',
								fieldLabel: ~'Файл сертифіката'~,
								name: 'cert_file'
						}, this.taGridCertInfo]
    });
				
				this.labelCertKey = new Ext.form.DisplayField({
      fieldLabel: ~'Інформація про ключ'~
				});
				
				this.fsCertKey = new Ext.form.FieldSet({
						title: ~'Налаштування приватного ключа'~,
						labelWidth: 220,
						items: [{
						  xtype: 'radio',
  						name: 'grid_auth_mode',	
								inputValue: 'cert',
								fieldLabel: ~'Використовувати для авторизації'~,
								listeners: rbl	
 					},{
								xtype: 'container',
								layout: 'column',
								defaults: {
										xtype: 'container',
										layout: 'form',
										labelWidth: 150
								},
								items: [{
										columnWidth: .65,
										style: {padding: '0 10px 0 0'},
										defaults: {
												anchor: '100%'
										},
										items: [this.labelCertKey, {
												xtype: 'fileuploadfield',
												fieldLabel: ~'Файл ключа'~,
												name: 'key_file'
										}]
								},{
										columnWidth: .35,
										defaults: {
												anchor: '100%',
										},
										items: [{
												xtype: 'checkbox',
												fieldLabel: ~'Автоматичний вхід'~,
												name: 'cert_auto',
												inputValue: 1,
												listeners: {
														check: function(cb, checked){
																self.tfCertPass.setDisabled(!checked);
																self.tfCertPassConfirm.setDisabled(!checked);
														}
												}								
										}, this.tfCertPass, this.tfCertPassConfirm]
								}]
						}]
    })
				
				this.fsMP = new Ext.form.FieldSet({
						title: ~'Налаштування MyProxy'~,
						labelWidth: 220,
						items: [{
						  xtype: 'radio',
							 name: 'grid_auth_mode',
							 inputValue: 'myproxy',
        fieldLabel: ~'Використовувати для авторизації'~,
								listeners: rbl
						},{
								xtype: 'container',
								layout: 'column',
								defaults: {
												xtype: 'container',
												layout: 'form',
												labelWidth: 150									 
								},
								items: [{
										columnWidth: .65,
										style: {padding: '0 10px 0 0'},
										defaults: {
												anchor: '100%'
										},
										items: [this.tfMPServer, this.tfMPLogin]								
								},{
										columnWidth: .35,
										defaults: {
												anchor: '100%'
										},
										items: [{
												xtype: 'checkbox',
												fieldLabel: ~'Автоматичний вхід'~,
												name: 'myproxy_auto',
												inputValue: 1,
												listeners: {
														check: function(cb, checked){
																self.tfMPPass.setDisabled(!checked);
//																self.tfMPPass.allowBlank = self.cert_pass_exists;
//																self.tfMPPass.validateValue(self.tfMPPass.getValue());
																self.tfMPPassConfirm.setDisabled(!checked);
														}
												}								
										}, this.tfMPPass, this.tfMPPassConfirm]
								}]																
						}]
    })
				
				this.colDefault = new app.RadioColumn({
				  header: ~'Основна'~,
						dataIndex: 'default',
						width: 45,
						menuDisabled: true
    });
				
				this.gridVO = new Ext.grid.EditorGridPanel({
					 title: ~'Віртуальні організації'~,
						store: this.interface.storeVO,
						height: 200,
						stripeRows: true,									
						viewConfig: {
							 forceFit: true
						},
						colModel: new Ext.grid.ColumnModel({
								defaults: {
										sortable: true,
										editor: new Ext.form.TextField({
												allowBlank: false
										})		
								},
								columns: [this.colDefault, {
								  header: ~'Ім\'я'~,
										dataIndex: 'name'
								},{
									 header: ~'Аліас'~,
										dataIndex: 'alias'
								},{
									 header: ~'Адреса сервера'~,
									 dataIndex: 'server'
								},{
									 header: ~'Порт'~,
										dataIndex: 'port'
								},{
									 header: ~'DN'~,
										dataIndex: 'dn'
								},{
									 xtype: 'actioncolumn',
										iconCls: 'x-action-delete',
										width: 25,
										editor: null,
										menuDisabled: true,
										handler: function(grid, rowIndex, colIndex) {
											 var s = grid.getStore(), n = s.getAt(rowIndex).data.name;
												Ext.Msg.show({
														title: ~'Видалення ВО'~,
														msg: String.format(~'Видалити ВО "{0}"?'~, n),
														iconCls: false,
														icon: Ext.MessageBox.WARNING,
														buttons: {yes: true, no: true},
														fn: function(btn) {
																if (btn == 'yes') {
																	 s.removeAt(rowIndex);
																}
														}
            })												
										}
								}]
      }),
						sm: new Ext.grid.RowSelectionModel({singleSelect:true}),
					 tbar: [{
						  text: ~'Додати'~,
								iconCls: 'x-action-add',
								handler: function(){
								  var vo = self.interface.storeVO.recordType, 
										r = new vo({
												'default': false, 
												name: 'new vo',
												alias: '',
												server: '',
												port: '',
												dn: ''
										});
										self.gridVO.stopEditing();
										self.interface.storeVO.insert(0, r);
										self.gridVO.startEditing(0, 0);
								}
						}]
    })
				
				this.formGridSettings = new Ext.form.FormPanel({
						url: 'modules/_.php',
						method: 'POST',
						baseParams: {
								cmd: 'save_grid_settings'
						},
						fileUpload: true,			
						items: [this.fsCert, this.fsCertKey, this.fsMP, this.gridVO],
						monitorValid: true,
						buttons: [{
								text: ~'Зберегти'~,
								formBind: true,
								handler: function(){
									 var s = '', i, d, params = {default_vo_alias: ''}, store = self.interface.storeVO;
										for (i = 0; i < store.getCount(); i++) {
										  d = store.getAt(i).data;
												s += '"' + d.alias + '" "' + d.server + '" "' + d.port + '" "' + d.dn + '" "' + d.name + '"\n';
												if (d['default'])
														params.default_vo_alias = d.alias;
										}
										params.vo_list = s;
										self.formGridSettings.getForm().submit({
												params: params,
												success: function(form, action) {
												  var o = action.result || {}, values = form.getValues();
														self.interface.userSettings.grid_auth_mode = values.grid_auth_mode;
														self.interface.userSettings.default_vo_alias = params.default_vo_alias;
												  self.interface.checkGridSettings(o.grid_cert_install);
														self.loadVO(o.grid_vo_install);
												}
										})
								}
						}]
				});
				
				var config = {
				  items: [this.formInterfaceSettings, this.formGridSettings]	
				}
				
		  Ext.applyIf(this, config);

    app.SettingsPanel.superclass.initComponent.call(this);
				
		}
});